/*
 * Copyright 2002-2008 the original author or authors.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.springframework.config.java.test;

import static org.hamcrest.CoreMatchers.is;
import static org.junit.Assert.assertThat;

import org.junit.Test;
import org.springframework.config.java.annotation.Bean;
import org.springframework.config.java.annotation.Configuration;
import org.springframework.context.ApplicationContext;

import test.common.beans.TestBean;


/**
 * Unit tests for {@link JavaConfigContextLoader}.
 */
public class JavaConfigContextLoaderTests {
    @Test
    public void testValidClassLocation() throws Exception {
        JavaConfigContextLoader loader = new JavaConfigContextLoader();
        ApplicationContext ctx = loader.loadContext(Config.class.getName());
        assertThat(ctx.containsBean("testBean"), is(true));
    }

    @Test
    public void testValidPackageLocation() throws Exception {
        JavaConfigContextLoader loader = new JavaConfigContextLoader();
        ApplicationContext ctx = loader.loadContext(Config.class.getPackage().getName());
        assertThat(ctx.containsBean("testBean"), is(true));
    }

    @Test(expected=IllegalArgumentException.class)
    public void testBogusLocation() throws Exception {
        JavaConfigContextLoader loader = new JavaConfigContextLoader();
        // should throw on this next call
        loader.loadContext("some.bogus.package");
    }
}

@Configuration
class Config {
    public @Bean TestBean testBean() {
        return new TestBean("white rabbit");
    }
}
